"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.useMapElement = useMapElement;
exports.MapContainer = MapContainer;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectWithoutPropertiesLoose"));

var _core = require("@react-leaflet/core");

var _leaflet = require("leaflet");

var _react = _interopRequireWildcard(require("react"));

function useMapElement(mapRef, props) {
  var _useState = (0, _react.useState)(null),
      map = _useState[0],
      setMap = _useState[1];

  (0, _react.useEffect)(function () {
    if (mapRef.current !== null && map === null) {
      var instance = new _leaflet.Map(mapRef.current, props);

      if (props.center != null && props.zoom != null) {
        instance.setView(props.center, props.zoom);
      } else if (props.bounds != null) {
        instance.fitBounds(props.bounds, props.boundsOptions);
      }

      if (props.whenReady != null) {
        instance.whenReady(props.whenReady);
      }

      setMap(instance);
    }
  }, [mapRef, map, props]);
  return map;
}

function MapContainer(_ref) {
  var children = _ref.children,
      className = _ref.className,
      id = _ref.id,
      placeholder = _ref.placeholder,
      style = _ref.style,
      whenCreated = _ref.whenCreated,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["children", "className", "id", "placeholder", "style", "whenCreated"]);
  var mapRef = (0, _react.useRef)(null);
  var map = useMapElement(mapRef, options);
  var createdRef = (0, _react.useRef)(false);
  (0, _react.useEffect)(function () {
    if (map != null && createdRef.current === false && whenCreated != null) {
      createdRef.current = true;
      whenCreated(map);
    }
  }, [map, whenCreated]);
  var context = (0, _react.useMemo)(function () {
    return map ? {
      __version: _core.CONTEXT_VERSION,
      map: map
    } : null;
  }, [map]);
  var contents = context ? /*#__PURE__*/_react.default.createElement(_core.LeafletProvider, {
    value: context
  }, children) : placeholder != null ? placeholder : null;
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: mapRef,
    className: className,
    id: id,
    style: style
  }, contents);
}