"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.VideoOverlay = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/objectWithoutPropertiesLoose"));

var _core = require("@react-leaflet/core");

var _leaflet = require("leaflet");

var VideoOverlay = (0, _core.createLayerComponent)(function createVideoOverlay(_ref, ctx) {
  var bounds = _ref.bounds,
      url = _ref.url,
      options = (0, _objectWithoutPropertiesLoose2.default)(_ref, ["bounds", "url"]);
  var instance = new _leaflet.VideoOverlay(url, bounds, options);

  if (options.play === true) {
    var _instance$getElement;

    (_instance$getElement = instance.getElement()) == null ? void 0 : _instance$getElement.play();
  }

  return {
    instance: instance,
    context: (0, _assign.default)({}, ctx, {
      overlayContainer: instance
    })
  };
}, function updateVideoOverlay(overlay, props, prevProps) {
  (0, _core.updateMediaOverlay)(overlay, props, prevProps);

  if (typeof props.url === 'string' && props.url !== prevProps.url) {
    overlay.setUrl(props.url);
  }

  var video = overlay.getElement();

  if (video != null) {
    if (props.play === true && !prevProps.play) {
      video.play();
    } else if (!props.play && prevProps.play === true) {
      video.pause();
    }
  }
});
exports.VideoOverlay = VideoOverlay;