import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/esm/objectWithoutPropertiesLoose";
import { CONTEXT_VERSION, LeafletProvider } from '@react-leaflet/core';
import { Map as LeafletMap } from 'leaflet';
import React, { useEffect, useMemo, useRef, useState } from 'react';
export function useMapElement(mapRef, props) {
  var _useState = useState(null),
      map = _useState[0],
      setMap = _useState[1];

  useEffect(function () {
    if (mapRef.current !== null && map === null) {
      var instance = new LeafletMap(mapRef.current, props);

      if (props.center != null && props.zoom != null) {
        instance.setView(props.center, props.zoom);
      } else if (props.bounds != null) {
        instance.fitBounds(props.bounds, props.boundsOptions);
      }

      if (props.whenReady != null) {
        instance.whenReady(props.whenReady);
      }

      setMap(instance);
    }
  }, [mapRef, map, props]);
  return map;
}
export function MapContainer(_ref) {
  var children = _ref.children,
      className = _ref.className,
      id = _ref.id,
      placeholder = _ref.placeholder,
      style = _ref.style,
      whenCreated = _ref.whenCreated,
      options = _objectWithoutPropertiesLoose(_ref, ["children", "className", "id", "placeholder", "style", "whenCreated"]);

  var mapRef = useRef(null);
  var map = useMapElement(mapRef, options);
  var createdRef = useRef(false);
  useEffect(function () {
    if (map != null && createdRef.current === false && whenCreated != null) {
      createdRef.current = true;
      whenCreated(map);
    }
  }, [map, whenCreated]);
  var context = useMemo(function () {
    return map ? {
      __version: CONTEXT_VERSION,
      map: map
    } : null;
  }, [map]);
  var contents = context ? /*#__PURE__*/React.createElement(LeafletProvider, {
    value: context
  }, children) : placeholder != null ? placeholder : null;
  return /*#__PURE__*/React.createElement("div", {
    ref: mapRef,
    className: className,
    id: id,
    style: style
  }, contents);
}