import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/esm/objectWithoutPropertiesLoose";
import { createElementHook, createLayerHook, updateMediaOverlay } from '@react-leaflet/core';
import { SVGOverlay as LeafletSVGOverlay } from 'leaflet';
import { forwardRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
export var useSVGOverlayElement = createElementHook(function createSVGOverlay(props, context) {
  var bounds = props.bounds,
      preserveAspectRatio = props.preserveAspectRatio,
      viewPort = props.viewPort,
      options = _objectWithoutPropertiesLoose(props, ["bounds", "preserveAspectRatio", "viewPort"]);

  var container = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
  container.setAttribute('xmlns', 'http://www.w3.org/2000/svg');

  if (preserveAspectRatio != null) {
    container.setAttribute('preserveAspectRatio', preserveAspectRatio);
  }

  if (viewPort != null) {
    container.setAttribute('viewPort', viewPort);
  }

  return {
    instance: new LeafletSVGOverlay(container, bounds, options),
    container: container,
    context: context
  };
}, updateMediaOverlay);
export var useSVGOverlay = createLayerHook(useSVGOverlayElement);

function SVGOverlayComponent(_ref, ref) {
  var children = _ref.children,
      options = _objectWithoutPropertiesLoose(_ref, ["children"]);

  var _useSVGOverlay$curren = useSVGOverlay(options).current,
      instance = _useSVGOverlay$curren.instance,
      container = _useSVGOverlay$curren.container;
  useImperativeHandle(ref, function () {
    return instance;
  });
  return container == null || children == null ? null : /*#__PURE__*/createPortal(children, container);
}

export var SVGOverlay = /*#__PURE__*/forwardRef(SVGOverlayComponent);