import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/esm/objectWithoutPropertiesLoose";
import { createLayerComponent, updateMediaOverlay } from '@react-leaflet/core';
import { VideoOverlay as LeafletVideoOverlay } from 'leaflet';
export var VideoOverlay = createLayerComponent(function createVideoOverlay(_ref, ctx) {
  var bounds = _ref.bounds,
      url = _ref.url,
      options = _objectWithoutPropertiesLoose(_ref, ["bounds", "url"]);

  var instance = new LeafletVideoOverlay(url, bounds, options);

  if (options.play === true) {
    var _instance$getElement;

    (_instance$getElement = instance.getElement()) == null ? void 0 : _instance$getElement.play();
  }

  return {
    instance: instance,
    context: _Object$assign({}, ctx, {
      overlayContainer: instance
    })
  };
}, function updateVideoOverlay(overlay, props, prevProps) {
  updateMediaOverlay(overlay, props, prevProps);

  if (typeof props.url === 'string' && props.url !== prevProps.url) {
    overlay.setUrl(props.url);
  }

  var video = overlay.getElement();

  if (video != null) {
    if (props.play === true && !prevProps.play) {
      video.play();
    } else if (!props.play && prevProps.play === true) {
      video.pause();
    }
  }
});